import { Injectable, Input } from '@angular/core'
import { Observable, of as observableOf } from 'rxjs'
import { map } from 'rxjs/operators'

import { Store } from './admin-manage/data.service'
import { ApiService, SurveyMeta, Project, Surveyor, Equipment } from '../openapi'

// const admin_models_menu_bar_query = gql`
// query admin_models_menu_bar {
//     admin_models_menu_bar{
//         name
//         items{
//             name
//             module
//         }
//     }
// }`

@Injectable()
export class AdminDataService {
    surveyMeta: SurveyMeta
    projectMap: Map<number, Project>
    surveyorMap: Map<number, Surveyor>
    equipmentMap: Map<number, Equipment>

    constructor(
        // private apollo: Apollo,
        public apiService: ApiService,
    ) {}

    getModelsMenuBar(): Observable<object[]> {
        console.warn('Migrate Graphql')
        return observableOf()
        // return this.apollo.query({
        //     query: admin_models_menu_bar_query
        // }).pipe(map(
        //     res => res['admin_models_menu_bar_query']
        // ))
    }

    getSurveyMeta(): Observable<SurveyMeta> {
        return this.apiService.getSurveyMetaApiSurveyMetaGet().pipe(map(
            surveyMeta => {
                this.surveyMeta = surveyMeta
                this.projectMap = new Map(surveyMeta.projects.map(i => [i.id, i]))
                this.surveyorMap = new Map(surveyMeta.surveyors.map(i => [i.id, i]))
                this.equipmentMap = new Map(surveyMeta.equipments.map(i => [i.id, i]))
                return surveyMeta
            }
        ))
    }
}