import { Injectable } from '@angular/core'
import { Router, RouterStateSnapshot, ActivatedRouteSnapshot } from '@angular/router'
import { Observable, forkJoin } from 'rxjs'

import { AdminDataService } from './admin-data.service'
import { AdminBasketDataService } from './admin-basket/data.service'
import { BasketNameOnly, SurveyMeta } from '../openapi'


@Injectable()
export class AdminResolver  {
    constructor(
        private router: Router,
        private dataService: AdminDataService,
        private basketDataService: AdminBasketDataService,
    ) {}

    resolve(
        route: ActivatedRouteSnapshot,
        state: RouterStateSnapshot,
        ): Observable<[BasketNameOnly[], SurveyMeta]> {
        return forkJoin([
            this.basketDataService.getBaskets(),
            this.dataService.getSurveyMeta(),
            //this.dataService.getModelsMenuBar(),
        ])
    }
}
